Loading...
Searching...
No Matches
juce::ARAHostModel::MusicalContext Class Reference

## Detailed Description

Helper class for the host side implementation of the ARA MusicalContext model object.

Its intended use is to add a member variable of this type to your host side MusicalContext implementation. Then it provides a RAII approach to managing the lifetime of the corresponding objects created inside the DocumentController. When the host side object is instantiated an ARA model object is also created in the DocumentController. When the host side object is deleted it will be removed from the DocumentController as well.

The class will automatically put the DocumentController into editable state for operations that mandate this e.g. creation, deletion or updating.

You can encapsulate multiple such operations into a scope with an ARAEditGuard in order to invoke the editable state of the DocumentController only once.

The documentation for this class was generated from the following file:

- juce_audio_processors_headless/format_types/juce_ARAHosting.h

Inheritance diagram for juce::ARAHostModel::MusicalContext:

## Public Member Functions

| MusicalContext (ARA::ARAMusicalContextHostRef hostRef, ARA::Host::DocumentController &dc, const ARA::ARAMusicalContextProperties &props)
| Creates a MusicalContext object.
void | update (const ARA::ARAMusicalContextProperties &props)
| Updates the state of the corresponding ARA model object.
Public Member Functions inherited from juce::ARAHostModel::ManagedARAHandle< MusicalContext, ARA::ARAMusicalContextRef >
| ManagedARAHandle (ARA::Host::DocumentController &dc, Ptr ptr) noexcept
| Constructor.
auto & | getDocumentController () const
| Returns the host side DocumentController reference.
Ptr | getPluginRef () const
| Returns the plugin side reference to the model object.

## Static Public Member Functions

static constexpr auto | getEmptyProperties ()
| Returns an ARA versioned struct with the structSize correctly set for the currently used SDK version.
static void | destroy (ARA::Host::DocumentController &, Ptr)
| Called by ManagedARAHandle to deregister the model object during the destruction of AudioModification.

## Additional Inherited Members

Public Types inherited from juce::ARAHostModel::ManagedARAHandle< MusicalContext, ARA::ARAMusicalContextRef >
using | Ptr

## Constructors and Destructors

## MusicalContext()

juce::ARAHostModel::MusicalContext::MusicalContext | ( | ARA::ARAMusicalContextHostRef | hostRef,
|  | ARA::Host::DocumentController & | dc,
|  | const ARA::ARAMusicalContextProperties & | props )

Creates a MusicalContext object.

During construction it registers an ARA MusicalContext model object with the DocumentController that refers to the provided hostRef. When this object is deleted the corresponding DocumentController model object will also be deregistered.

You can acquire a correctly versioned ARA::ARAMusicalContextProperties struct by calling getEmptyProperties().

Places the DocumentController in editable state.

See also
  ARAEditGuard

## Member Functions

## getEmptyProperties()

constexpr auto juce::ARAHostModel::MusicalContext::getEmptyProperties | ( |  | ) |

inline static constexpr

Returns an ARA versioned struct with the structSize correctly set for the currently used SDK version.

You should leave structSize unchanged, and fill out the rest of the fields appropriately for the host implementation of the ARA model object.

References juce::makeARASizedStruct().

## update()

void juce::ARAHostModel::MusicalContext::update | ( | const ARA::ARAMusicalContextProperties & | props | ) |

Updates the state of the corresponding ARA model object.

Places the DocumentController in editable state.

You can use getEmptyProperties() to acquire a properties struct where the structSize field has already been correctly set.

## destroy()

void juce::ARAHostModel::MusicalContext::destroy | ( | ARA::Host::DocumentController & | ,
|  | Ptr | )

static

Called by ManagedARAHandle to deregister the model object during the destruction of AudioModification.

You shouldn't call this function manually.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited